import Toybox.Graphics;
import Toybox.Lang;
import Toybox.System;
import Toybox.WatchUi;

class TestHrHistView extends WatchUi.WatchFace {

    function initialize() {
        WatchFace.initialize();
    }

    // Load your resources here
    function onLayout(dc as Dc) as Void {
        setLayout(Rez.Layouts.WatchFace(dc));
    }

    // Called when this View is brought to the foreground. Restore
    // the state of this View and prepare it to be shown. This includes
    // loading resources into memory.
    function onShow() as Void {
    }

    // Update the view
    function onUpdate(dc as Dc) as Void {
        var i = 0;
        var i_date_null = 0;
        var i_null = 0;
        var i_nonnull = 0;
        var i_invalid = 0;

        var j = 0;
        var j_date_null = 0;
        var j_null = 0;
        var j_nonnull = 0;

        System.println("Current time: " + Time.now().value());

        //you may have to do loop by loop as there's a watchdog error if you enable both loops at once... the venu2 is harsh on it's timings!
        System.println("---");
        System.println("hr-history");
        var hrI = ActivityMonitor.getHeartRateHistory(null, true);        
        if (hrI != null) {
            var sample = hrI.next();
            while (sample != null) {
                var sX = sample.heartRate;
                if (sample.when.value() != null) {
                    if (sample.heartRate == null) {
                        i_null++;
                    } else {
                        if (sample.heartRate == 255) {
                            i_invalid++;                             
                        } else {
                            i_nonnull++;
                            System.println(sample.when.value() + " " + sX); // actual data: timestamp & hr not null
                        } 
                    }       
                } else {
                    i_date_null++;
                }
                i++;
                sample = hrI.next();
            }
        }
        System.println(i + " date null:" + i_date_null + " invalid:" + i_invalid + " hr null:" + i_null + " hr not null:" + i_nonnull);

/*
        System.println("hr-sensorhistory");
        var hrS = SensorHistory.getHeartRateHistory({});
        if (hrS != null) {
            var sample = hrS.next();
            while (sample != null) {
                if (sample.when.value() != null) {
                    if (sample.data == null) {
                        j_null++;
                    } else {
                        j_nonnull++;
                    System.println(sample.when.value() + " " + sample.data); // actual data: timestamp & hr not null
                    }       
                } else {
                    j_date_null++;
                }
                j++; 
                sample = hrS.next();
            }
        }
        System.println(j + " date null:" + j_date_null + " j null:" + j_null + " j not null:" + j_nonnull);
*/


        // Get and show the current time
        var clockTime = System.getClockTime();
        var timeString = Lang.format("$1$:$2$", [clockTime.hour, clockTime.min.format("%02d")]);
        var view = View.findDrawableById("TimeLabel") as Text;
        view.setText(i + "-" + j);

        // Call the parent onUpdate function to redraw the layout
        View.onUpdate(dc);
    }

    // Called when this View is removed from the screen. Save the
    // state of this View here. This includes freeing resources from
    // memory.
    function onHide() as Void {
    }

    // The user has just looked at their watch. Timers and animations may be started here.
    function onExitSleep() as Void {
    }

    // Terminate any active timers and prepare for slow updates.
    function onEnterSleep() as Void {
    }

}
